[tool.poetry]
name = "flywheel-gear-toolkit"
version = "0.6.21"
license = "MIT"
readme = "README.md"
description = "Tooling for developing Flywheel gears"
authors = ["Flywheel <support@flywheel.io>"]
repository = "https://gitlab.com/flywheel-io/public/gear-toolkit"
documentation = "https://gear-toolkit.readthedocs.io/en/latest/"

[tool.poetry.dependencies]
python = "^3.8"

"backports.zoneinfo" = {version = "^0", python = "3.8"}
dotty-dict = "^1.2.1"
flywheel-gears = "^0"
jsonschema = "^4.0.0"

flywheel-bids = { version = "^1.0.8", optional = true,  python = "^3.7.1,<4.0"}
flywheel-sdk = { version = ">=14.2.0", optional = true }
fw-file = { version = ">=2", optional = true }
nibabel = { version = "^5.1.0", optional = true}
nipype = { version = "^1.6", optional = true}
numpy = { version = "^1", optional = true }
fw-gear = "0.1.3"

[tool.poetry.dev-dependencies]
docker = "^6.0.0"
mkdocs = "^1.3.0"
mkdocs-material = "^9.1.8"
mkdocs-minify-plugin = "^0"
pytest = "^7.0.0"
pytest-cov = "^4.0.0"
pytest-mock = "^3.3.1"

[tool.poetry.extras]
all = ["numpy", "fw-file", "flywheel-bids", "flywheel-sdk", "nipype", "nibabel"]
dicom = ["fw-file", "nibabel"]
fw-file = ["fw-file"]
nipype = ["nibabel", "nipype"]
numpy = ["numpy"]
sdk = ["flywheel-bids","flywheel-sdk"]

[tool.poetry.group.dev.dependencies]
pre-commit = "^3.3.3"

[tool.pytest.ini_options]
addopts = ["--cov=flywheel_gear_toolkit"]
testpaths = ["tests"]

[tool.coverage.run]
omit = [
    "flywheel_gear_toolkit/utils/datatypes.py",
    "flywheel_gear_toolkit/utils/decorators.py",
    "flywheel_gear_toolkit/testing/*"
]

[tool.poetry.plugins."mkdocs.plugins"]
fw-docs = "docs.generate_docs:FWPlugin"

[tool.ruff]
ignore-init-module-imports = true
ignore = ["D", "E402", "E722", "F401", "F403", "F811", "F841", "PLR0915"]
# Allow fix for all enabled rules (when `--fix`) is provided.
fixable = ["ALL"]

[build-system]
requires = ["poetry-core"]
build-backend = "poetry.core.masonry.api"
